<?php
/**
 * ShopEx licence
 *
 * @copyright  Copyright (c) 2005-2010 ShopEx Technologies Inc. (http://www.shopex.cn)
 * @license  http://ecos.shopex.cn/ ShopEx License
 */
class topc_ctl_member_deposit extends topc_ctl_member{

    private function checkoutAmount($amount)
    {

        if( !is_numeric($amount) )
            throw new LogicException('充值金额必须为数字');

        if( $amount <= 0 )
            throw new LogicException('充值金额必须大于0');

        if( $amount >= 10000000)
            throw new LogicException('请勿充值过大的金额');

        if(  ( (int)($amount*100) ) != ($amount * 100)  )
            throw new LogicException('充值金额的最小单位不得小于分');

    }

    public function view() {

        $userId = userAuth::id();
        $page = input::get('pages') ? input::get('pages') : 1;
        $rowNum = 10;

        $deposit = app::get('topc')->rpcCall('user.deposit.getInfo', ['user_id'=>$userId, 'with_log'=>'true', 'page'=>intval($page), 'row_num'=>intval($rowNum)]);

        $pagedata['deposit'] = $deposit;
        $pagedata['action'] = 'topc_ctl_member_deposit@view';

        //分页处理
        $pagedata['pagers'] = array(
            'link'=>url::action('topc_ctl_member_deposit@view',['pages'=>time()]),
            'current'=>$page ? $page : 1,
            'total'=>ceil($deposit['count'] / $rowNum),
            'token'=>time(),
        );

        $this->action_view = "deposit/index.html";
        return $this->output($pagedata);
    }

    //s输入充值金额的页面
    public function rechargeSubmit() {
        $this->action_view = "deposit/recharge_form.html";
        return $this->page('topc/member/deposit/recharge_form.html',$pagedata);
    }

    //选择支付方式的页面
    public function rechargePay() {
        $amount = input::get('amount');

        try{
            $this->checkoutAmount($amount);
        }
        catch(Exception $e)
        {
            return $this->splash('error',null,$e->getMessage());
        }

        $userId = userAuth::id();

        $payType['platform'] = 'ispc';
        $payments = app::get('topc')->rpcCall('payment.get.list',$payType,'buyer');
        foreach($payments as $key=>$payment)
        {
            if($payment['app_id'] == 'deposit')
                unset($payments[$key]);
        }

        $pagedata['amount']   = $amount;
        $pagedata['payments'] = $payments;

        $this->action_view = "deposit/recharge_pay.html";
        return $this->page('topc/member/deposit/recharge_pay.html',$pagedata);
    }

    public function doRecharge()
    {
        $payment['user_id'] = userAuth::id();
        $payment['user_name'] = userAuth::getLoginName();

        $payment['money'] = input::get('amount');
        try{
            $this->checkoutAmount($payment['money']);
        }
        catch(Exception $e)
        {
            return $this->splash('error',null,$e->getMessage());
        }

        $payment['pay_app_id'] = input::get('pay_app_id');
        $payment['platform'] = 'pc';

        if($payment['pay_app_id'] == 'deposit')
            throw new LogicException('充值方式不可使用预存款!');

        $result = app::get('topc')->rpcCall('payment.deposit.recharge', $payment);
        $paymentId = $result['paymentId'];

        return redirect::action('topc_ctl_member_deposit@rechargeResult', ['payment_id'=>$paymentId]);

    }

    //返回结果页面
    public function rechargeResult() {
        $paymentId = input::get('payment_id');

        $payment = app::get('topc')->rpcCall('payment.bill.get', ['payment_id'=>$paymentId, 'fields'=>'status,cur_money']);
        if($payment['status'] == 'succ')
        {
            return $this->page('topc/member/deposit/recharge_success.html',$pagedata);
        }
        else
        {
            return $this->page('topc/member/deposit/recharge_failed.html',$pagedata);
        }
    }
}
